/*
 * SF-Reader: event.C
 *
 *   ٥Ƚ
 *
 * (C)Copyright 2009, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdio.h>
#include <tcode.h>
#include <errcode.h>
#include <btron/message.h>
#include <btron/libapp.h>
#include "sfread.h"
#include "db.h"


W sfread_window_init()
{
    W err;
    RECT r_btn_read;
    static TC name_btn_read[] = 
        {MC_STR, L"ɤ߹"}; /* ݻɬפ */

    /* ɤ߹ߥܥ */
    r_btn_read.c.top = 12*2;
    r_btn_read.c.right = SFREAD_WINDOW_WIDTH - 12*6;
    r_btn_read.c.left = r_btn_read.c.right - 12*12;
    r_btn_read.c.bottom = r_btn_read.c.top + 12*3;

    err = ccre_msw(info.wid, P_DISP, &r_btn_read,
                   name_btn_read, NULL);
    if (err < 0) {
        printf("SF-Reader: Failed to create read button (%d).\n", err);
        goto err_ret0;
    }
    info.btn_read = err;

    return 0;

 err_ret0:
    return err;
}


W sfread_window_cleanup()
{
    /* ɤ߹ߥܥκ */
    cdel_par(info.btn_read, CLR);

    /* ɥǡκ */
    if (info.data != NULL) {
        sfread_doc_cleanup(info.data);
        info.data = NULL;
    }

    return 0;
}


void sfread_idlefn()
{
    if (info.busy) {
        gset_ptr(PS_BUSY, NULL, (COLOR)-1, (COLOR)-1);
        return;
    }
        
    if (wevt.s.wid == info.wid && wevt.s.cmd == W_WORK
        && (wevt.s.stat & ES_CMD) == 0) {
        gset_ptr(PS_SELECT, NULL, (COLOR)-1, (COLOR)-1);
    }

    /* ѡĤ */
    cidl_par(info.wid, &(wevt.s.pos));
}


W sfread_msgfn(MESSAGE* msg)
{
    W err;
    SFReadMessage msgbody;

    err = rcv_msg(MM_ALL, (MESSAGE*)&msgbody, sizeof(msgbody), 
                  NOWAIT|CLR);
    if (err < 0) {
        clr_msg(MM_ALL, MM_ALL);
        return 0;
    }

    if (err != 0 /* ¾ΥץΥå */
        || msgbody.msg_type != MS_TYPE7
        || msgbody.msg_size != sizeof(msgbody) - sizeof(W)*2) {
        return 0;
    }

    if (msgbody.data != NULL) {
        if (info.data != NULL) {
            sfread_doc_cleanup(info.data);
        }
        info.data = msgbody.data;

        /* Ķ */
        sfread_clear_screen();
        sfread_doc_render(getMemGid(info.mgid), info.data);

        /* ºݤΥ꡼˺ */
        sfread_dspfn(0, -1, NULL);
    }

    info.busy = False;
    gset_ptr(PS_SELECT, NULL, (COLOR)-1, (COLOR)-1);

    //sig_buz(0);

    return 0;
}


static void sfread_updateMenu()
{
    /* ɥ˥塼ι */
    wget_dmn(&(mainMenuItems[nMainMenuItems-2].ptr));
    mset_itm(info.mid, nMainMenuItems-2,
             &(mainMenuItems[nMainMenuItems-2]));

    /* ʪ˥塼ι */
    oget_men(0, NULL, &(mainMenuItems[nMainMenuItems-1].ptr),
             NULL, NULL);
    mset_itm(info.mid, nMainMenuItems-1,
             &(mainMenuItems[nMainMenuItems-1]));
}


static void sfread_execRead()
{
    if (!info.busy) {
        info.busy = True;
        gset_ptr(PS_BUSY, NULL, (COLOR)-1, (COLOR)-1);

        /* ǡˤ */
        if (info.data != NULL) {
            sfread_doc_cleanup(info.data);
            info.data = NULL;
        }
        sfread_clear_screen();
        sfread_dspfn(0, -1, NULL);
 
        /* ɤ߹ߤγ */
        sftask_cardread();
    }
}


static W sfread_execMenu(W sts)
{
    W sts_u = (sts >> 8) & 0xff;
    W sts_l = sts & 0xff;

    switch (sts) {
    case 0:
        return 0;
    case 0x0001:
        /* λ˥塼: ԥȥΥ֥륯åλƱ */
        return sfread_finfn(0, 0);
    case 0x0101:
        sfread_execRead();
        return 0;
    case 0x0201:
        if (!info.busy) {
            sfread_put_tray(info.data, False);
        }
        return 0;
    default:
        if (sts_u == nMainMenuItems - 2) {
            wexe_dmn(sts_l);
            return 0;
        }
        if (sts_u == nMainMenuItems - 1) {
            oexe_apg(0, sts_l);
            return 0;
        }
        printf("SF-Reader: Unknown menu-item: %08x.\n", sts);
        return 0;
    }
}


W sfread_menufn()
{
    W err, sts;

    /* ˥塼ܤι(ǰΤ) */
    sfread_updateMenu();

    /* ˥塼ɽ */
    err = msel_men(info.mid, wevt.s.pos);
    if (err < 0) {
        printf("SF-Reader: Failed to display menu (%d).\n", err);
        return 0;
    }
    sts = err;

    /* ˥塼μ¹ */
    return sfread_execMenu(sts);
}


static void sfread_draw()
{
    /* ˤĤϤ򤤤äõ */
    cdsp_pwd(info.wid, NULL, P_NODISP);

    /* */
    // wera_end(info.wid, NULL);
    copyMemGid(info.wgid, 0, 0, info.mgid);

    /* ĤϤ */
    cdsp_pwd(info.wid, NULL, P_DISP);
}


void sfread_dspfn(W ix, W mode, RECT* newr)
{
    if (ix != 0) {
        return;
    }

    /* ʲξˤĤƤϺ */
    if (mode == 2 && mode == 4 && mode == 8) {
        return;
    }

    /* ɽΤȤϡwsta_dspwend_dsp  */
    if (mode == -1) {
        sfread_draw();
        return;
    }

    /*  */
    do {
        if (wsta_dsp(info.wid, NULL, NULL) == 0) {
            break;
        }
        sfread_draw();
    } while (wend_dsp(info.wid) > 0);
}


void sfread_stsfn(W ix, W sts)
{
    if (ix != 0) {
        return;
    }

    /* sts <= 2 ΤȤϥѡĤɽʤȤʤ(餷) */
    if (sts <= 2) {
        cdsp_pwd(info.wid, NULL, P_DISP);
    }
}


W sfread_keyfn()
{
    W err, sts;

    if ((wevt.s.stat & ES_CMD) != 0) {
        /* ˥塼ܤι(ǰΤ) */
        sfread_updateMenu();

        /* 硼ȥåȥθ */
        err = mfnd_key(info.mid, wevt.s.wid);
        if (err <= 0) {
            return 0;
        }
        sts = err;

        /* ˥塼μ¹ */
        return sfread_execMenu(sts);
    }

    return 0;
}


#define SEL_MODE_FLICKER (-1)
#define SEL_MODE_DISP    1
#define SEL_MODE_ERASE   0

static W sfread_dragdrop(RECT* r)
{
    W err, dgid;
    Bool locked;
    RECT vrect, frect;
    SEL_RGN sel;
    PNT sp, ep;

    gset_ptr(PS_GRIP, NULL, (COLOR)-1, (COLOR)-1);

    sel.sts = 0; /*  */
    sel.rgn.r = *r;

    locked = False;
    dgid = wsta_drg(info.wid, 0);
    if (dgid < 0) {
        printf("SF-Reader: Failed to start drag (%d)\n", dgid);
        return dgid;
    }

    adsp_sel(dgid, &sel, SEL_MODE_DISP);

    gget_vis(info.wgid, &vrect);
    gget_fra(dgid, &frect);

    sp = wevt.s.pos;

    for (;;) {
        err = wget_drg(&ep, &wevt);
        if (err == EV_BUTUP) {
            break;
        }

        if ((sp.x == ep.x) && (sp.y == ep.y)) {
            continue;
        }

        if (vrect.c.left <= ep.x && ep.x < vrect.c.right
            && vrect.c.top <= ep.y && ep.y < vrect.c.bottom) {
            if (locked) {
                adsp_sel(dgid, &sel, SEL_MODE_ERASE);
                gset_vis(dgid, vrect);
                gloc_env(dgid, 0);
                locked = False;
            }
        }
        else {
            if (!locked) {
                adsp_sel(dgid, &sel, SEL_MODE_ERASE);
                gloc_env(dgid, 1);
                gset_vis(dgid, frect);
                locked = True;
            }
        }

        adsp_sel(dgid, &sel, SEL_MODE_ERASE);
        sel.rgn.r.c.left += ep.x - sp.x;
        sel.rgn.r.c.right += ep.x - sp.x;
        sel.rgn.r.c.top += ep.y - sp.y;
        sel.rgn.r.c.bottom += ep.y - sp.y;
        adsp_sel(dgid, &sel, SEL_MODE_DISP);

        sp = ep;
    }

    adsp_sel(dgid, &sel, SEL_MODE_ERASE);
    if (locked) {
        gset_vis(dgid, vrect);
        gloc_env(dgid, 0);
        locked = False;
    }
    wend_drg();

    //gset_ptr(PS_SELECT, NULL, (COLOR)-1, (COLOR)-1);
    return 0;
}


W sfread_presfn(W ix)
{
    RECT r;
    PNT sp, ep;
    W err;
    W clktype;
    W pid;

    if (ix != 0) {
        return 0;
    }

    /* ѡĤ򸡺ѡĤϤν */
    err = cfnd_par(info.wid, wevt.s.pos, &pid);
    if (err >= 0 && pid > 0) {
        if (pid == info.btn_read) {
            do {
                err = cact_par(pid, &wevt);
                if (err < 0) {
                    return 0;
                }
            } while ((err & 0x2000) != 0);

            if ((err & 0x1000) != 0) {
                sfread_execRead();
            }
            return 0;
        }

        printf("SF-Reader: Unhandled widget %d\n", pid);
        return 0;
    }

    /* ɥåɥåפʤ */ 
    if (info.busy || info.data == NULL) {
        return 0;
    }

    r.c.left = 12*1;
    r.c.top = 12*7 + 20;
    r.c.right = r.c.left + 8*SFREAD_COLUMNS;
    r.c.bottom = r.c.top + 18*info.data->nrows;

    if (wevt.s.pos.x < r.c.left || wevt.s.pos.x >= r.c.right
        || wevt.s.pos.y < r.c.top || wevt.s.pos.y >= r.c.bottom) {
        return 0;
    }

    clktype = wchk_dck(wevt.s.time);
    if (clktype != W_PRESS && clktype != W_QPRESS) {
        return 0;
    }

    /* ɽꥢΥɥåɥå */
    sp = wevt.s.pos;

    err = sfread_dragdrop(&r);
    if (err < 0 || wevt.s.wid == info.wid) {
        return 0;
    }

    ep = wevt.s.pos;

    if (wevt.s.wid <= 0) {
        displayError((TC[]){L"ΥɥˤŽߤǤޤ"});
        return 0;
    }

    err = sfread_put_tray(info.data, True);
    if (err < 0) {
        displayError((TC[]){L"ǡŽߤ˼Ԥޤ"});
        return 0;
    }

    wevt.r.type = EV_REQUEST;
    wevt.r.cmd = W_PASTE;
    wevt.r.r.p.lefttop = ep;
    wevt.r.r.c.right = ep.x - sp.x + r.c.left;
    wevt.r.r.c.bottom = ep.y - sp.y + r.c.top;

    err = wsnd_evt(&wevt);
    if (err < 0) {
        displayError((TC[]){L"ŽߤΤ˼Ԥޤ"});
        tset_dat(NULL, 0);
        return 0;
    }

    err = wwai_rsp(&wevt, W_PASTE, 10000); /* 10 sec */
    if (err < 0) {
        displayError((TC[]){L"Ž褫αޤ"});
        tset_dat(NULL, 0);
        return 0;
    }

    /* ɥڤؤ */
    wswi_wnd(wevt.s.wid, NULL);

    return 0;
}


W sfread_finfn(W ix, W mode)
{
    pdsp_msg(NULL);

    return 1;
}

