/* libpasori communicate BTRON ver. */

#include <basic.h>
#include <bstdio.h>
#include <bstdlib.h>
#include <tcode.h>
#include <btron/device.h>
#include "libpasori_liblocal.h"


void dbg_dump(unsigned char *b,unsigned int size){
    int i;
    if(size > 255) size = 255;
    for(i=0;i!=size;i++){
        Log("%02X ",b[i]);
    }
    Log("\n");
}


void pasori_close(pasori* pp)
{
    if(!pp) return;
    cls_dev(pp->dd, 0, NULL);
    free(pp);
}


pasori* pasori_open(char *p) /* FIXME: unused arg. */
{
    pasori *pp;
    TC devname[] = {TK_p, TK_a, TK_s, TK_o, TK_r, TK_i, TNULL};
    pp = (pasori *)malloc(sizeof(pasori));
    if (pp == NULL) {
        return NULL;
    }

    pp->dd = opn_dev(devname, D_UPDATE, NULL);
    if (pp->dd < 0) {
        free(pp);
        return NULL;
    }

    return pp;
}


int pasori_send(pasori* pp,uint8* data,uint8 size)
{
    W err, asize, error;
    uint8 msg[256];
    Log("(send) send:");
    dbg_dump(data,size);
    err = wri_dev(pp->dd, 0, data, size, &asize, &error);
    if (err < 0) {
        return -1;
    }

    err = rea_dev(pp->dd, 0, msg, sizeof(msg), &asize, &error);
    if (err < 0 || asize <= 0) {
        return -1;
    }
    Log("(ACK?) recv:");
    dbg_dump(data,asize);

    if (asize != 6 || msg[4] != 0xff) {
        return -1;
    }

    return 0;
}


int pasori_recv(pasori* pp,uint8* data,uint8 size)
{
    W err, asize, error;

    err = rea_dev(pp->dd, 0, data, size, &asize, &error);
    if (err < 0 || asize <= 0) {
        Log("(recv) ERROR\n");
        return err;
    }
    else {
        Log("(recv) recv:");
        dbg_dump(data,asize); 
        return asize;
    }
}

