/*
 * SF-Reader: main.C
 *
 *   ᥤ롼
 *
 * (C)Copyright 2009, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdio.h>
#include <tcode.h>
#include <errcode.h>
#include <btron/message.h>
#include <btron/libapp.h>
#include "sfread.h"
#include "db.h"


/*
 * ɥ
 */
SFReadInfo info;
static WINFOREC winfo[2];
static WFUNCREC wfunc;


/*
 * ˥塼
 */
static TC m_finish[] = {MC_STR|MC_KEY1, L"Žλ"};
static TC m_update[] = {MC_STR|MC_KEY1, L"ҥɤ߹"};
static TC m_edit[] = {MC_STR, L"Խ"|MC_STR|MC_KEY1, L"åȥ졼ʣ"};

MENUITEM mainMenuItems[] = {
    {0, 0, 0, 0, m_finish},
    {0, 0, 0, 0, m_update},
    {0, 0, 0, 0, m_edit},
    {0, 0, 0, 0, NULL}, /* ɥ */
    {0, 0, 0, 0, NULL}, /* ʪ */
};
int nMainMenuItems = sizeof(mainMenuItems) / sizeof(mainMenuItems[0]);


/*
 * Ľ򥷥ƥåꥢɽ
 * (sts ϥɥåȤο)
 */
void sftask_display_status(TC* base, int sts)
{
    TC msg[256];
    int i;

    for (i = 0; base[i] != TNULL; i++) {
        msg[i] = base[i];
    }
    while (sts > 0) {
        msg[i] = TK_PROD;
        i++;
        sts--;
    }
    msg[i] = TNULL;

    pdsp_msg(msg);
}


/*
 * ưåפ򸡺Ŭڤʾˤϰ۾ｪλ
 */
static W checkExecType(MESSAGE* msg)
{
    switch (msg->msg_type) {
    case EXECREQ:
        return 0;
    case FUSENREQ:
        oend_prc(((M_FUSENREQ*)msg)->vid, NULL, 0);
        return -1;
    case DISPREQ:
        oend_req(((M_DISPREQ*)msg)->vid, 1);
        return -1;
    case PASTEREQ:
        oend_req(((M_PASTEREQ*)msg)->vid, 1);
        return -1;
    case TADREQ:
        oend_req(((M_TADREQ*)msg)->vid, 1);
        return -1;
    default:
        return -1;
    }
}


/*
 * ᥤؿ
 */
W MAIN(MESSAGE* msg)
{
    M_EXECREQ* msg_exec = (M_EXECREQ*)msg;
    TC title[] = {L"ӣơݣң"};
    RECT wrect;
    WDSTAT stat;
    W err;
    W ret = 0;

    /* Ƽ */
    opendbox(NULL, 0, 0);
    getscreen();
    initstdpnl();

    pdsp_msg(NULL);

    /* ưפΥå */
    err = checkExecType(msg);
    if (err < 0) {
        displayError((TC[]){L"ưˡ۾Ǥ"});
        ret = err;
        goto err_ret0;
    }

    memset(&info, 0, sizeof(SFReadInfo));
    info.prog = &(msg_exec->self);
 
    /* 䵤ɤ߹ */
    err = get_fsn_data(msg_exec, &(info.fusen_old), sizeof(SFReadFusen));
    if (err >= 0) {
        memcpy(&(info.fusen), &(info.fusen_old), sizeof(SFReadFusen));
        info.fusen.dlen = sizeof(SFReadFusen) - sizeof(UH);
    }
    else {
        //memset(&(info.fusen_old), 0, sizeof(SFReadFusen));
        info.fusen.dlen = sizeof(SFReadFusen) - sizeof(UH);
        info.fusen.rsv1 = 0;
        info.fusen.wrect.c.left = 50;
        info.fusen.wrect.c.top = 50;
    }

    /* ɥ */
    info.fusen.wrect.c.right = 
        info.fusen.wrect.c.left + SFREAD_WINDOW_WIDTH;
    info.fusen.wrect.c.bottom = 
        info.fusen.wrect.c.top + SFREAD_WINDOW_HEIGHT;

    /* ˥塼Υץ */
    wget_dmn(&(mainMenuItems[nMainMenuItems-2].ptr));
    oget_men(0, NULL, &(mainMenuItems[nMainMenuItems-1].ptr),
             NULL, NULL);

    err = mcre_men(nMainMenuItems, mainMenuItems, NULL);
    if (err < 0) {
        displayError((TC[]){L"˥塼Υץ˼Ԥޤ"});
        ret = err;
        goto err_ret0;
    }
    info.mid = err;

    /* ĶΥץ */
    info.mgid = createMemGid(SFREAD_WINDOW_WIDTH, SFREAD_WINDOW_HEIGHT, 
                             SFREAD_BGCOLOR);
    if (info.mgid == NULL) {
        displayError((TC[]){L"ĶΥץ˼Ԥޤ"});
        ret = ER_NOMEM;
        goto err_ret1;
    }
    sfread_clear_screen();

    /* ɤ߹ѥ֥εư */
    err = sftask_start();
    if (err < 0) {
        displayError((TC[]){L"֥γϤ˼Ԥޤ"});
        ret = err;
        goto err_ret2;
    }

    /* ɥΥץ */
    wrect = info.fusen.wrect;

    err = wopn_wnd(WA_WORK, msg_exec->pwid, &wrect, 
                   &(msg_exec->r), SFREAD_PICT, 
                   title, NULL, NULL);
    if (err < 0) {
        displayError((TC[]){L"ɥΥץ˼Ԥޤ"});
        ret = err;
        goto err_ret3;
    }
    info.wid = err;
    info.wgid = wget_gid(info.wid);

    wset_wrk(info.wid, &wrect);
    gset_vis(info.wgid, wrect);

    /* Ȥμ¹Գ; ̿ŪǤϤʤΤǥ顼åϤʤ */
    osta_prc(msg_exec->vid, info.wid);

    /* ɥطν */
    sfread_window_init();

    /* ٥ȥ롼 */
    memset(winfo, 0, sizeof(winfo));
    winfo[0].wid = info.wid;
    winfo[0].chgmod = 0;
    winfo[1].wid = 0; /* ǽ */

    memset(&wfunc, 0, sizeof(wfunc));
    wfunc.bgfn    = NULL;
    wfunc.idlefn  = sfread_idlefn;
    wfunc.msgfn   = sfread_msgfn;
    wfunc.menufn  = sfread_menufn;
    wfunc.dspfn   = sfread_dspfn;
    wfunc.stsfn   = sfread_stsfn;
    wfunc.keyfn   = sfread_keyfn;
    wfunc.presfn  = sfread_presfn;
    wfunc.finfn   = sfread_finfn;
    wfunc.pastefn = NULL;
    wfunc.respfn  = NULL;
    wfunc.scrlfn  = NULL;
    wfunc.devfn   = NULL;
    wfunc.vobjfn  = NULL;

    do {
        err = evt_loop(&wfunc, winfo);
    } while (err == 0);

    /* ɥطΥ꡼󥢥å */
    sfread_window_cleanup();

    /* ɥκɸ䵤¸ */
    stat.attr = WA_WORK;
    err = wget_sts(info.wid, &stat, NULL);
    if (err >= 0) {
        info.fusen.wrect = stat.r;
    }

    /* ɥΥ */
    wcls_wnd(info.wid, CLR);

    /* 䵤¸ܲȤμ¹Խλ(oend_prc) */
    put_fsn_data(msg_exec, &(info.fusen), &(info.fusen_old), True);

    ret = 0;
    /* FALLTHROUGH */
 err_ret3:
    sftask_terminate(); /* ǤDBĤ礬ꡢ̩ˤϤޤ */
    sfread_suica_cleanupDB();
 err_ret2:
    releaseMemGid(info.mgid);
 err_ret1:
    mdel_men(info.mid);
 err_ret0:
    closedbox();
    return ret;
}

