/*
 * SF-Reader: memgid.c
 *
 *   Ķ
 *
 * (C)Copyright 2009, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdlib.h>
#include <errcode.h>
#include <btron/dp.h>
#include <btron/libapp.h>
#include "memgid.h"


MemGid* createMemGid(int width, int height, COLOR bgc)
{
    W   err;
    MemGid* mgid;

    mgid = (MemGid*)malloc(sizeof(MemGid));
    if (mgid == NULL) {
        goto err_ret0;
    }
    memset(mgid, 0, sizeof(*mgid));

    mgid->bgcol = bgc;
    // getscreen();
    mgid->bmp.planes = SCREEN.planes;
    mgid->bmp.pixbits = SCREEN.pixbits;
    mgid->bmp.bounds.c.left = 0;
    mgid->bmp.bounds.c.top = 0;
    mgid->bmp.bounds.c.right = width;
    mgid->bmp.bounds.c.bottom = height;

    err = bmalloc(&(mgid->bmp));
    if (err < 0) {
        goto err_ret1;
    }

    /* 顼ޥåפμ */
    err = GetStdCSPEC(&(mgid->cspec), mgid->bmp.planes, mgid->bmp.pixbits);
    if (err < 0) {
        goto err_ret2;
    }

    /* Ķ򥪡ץ󤹤 */
    err = gopn_mem(NULL, &(mgid->bmp), (B*)&(mgid->cspec));
    if (err < 0) {
        goto err_ret2;
    }
    mgid->gid = err;

    return mgid;

 err_ret2:
    bfree(&(mgid->bmp));
 err_ret1:
    free(mgid);
 err_ret0:
    return NULL;
}


void releaseMemGid(MemGid* mgid)
{
    if (mgid == NULL) {
        return;
    }
    if (mgid->gid >= 0) {
        gcls_env(mgid->gid);
    }
    bfree(&(mgid->bmp));
    free(mgid);
}


W resizeMemGid(MemGid* mgid, int width, int height)
{
    W err;

    if (mgid == NULL || mgid->gid < 0) {
        return ER_PAR;
    }

    /* ӥåȥޥåסĶ */
    gcls_env(mgid->gid);
    bfree(&(mgid->bmp));

    /* ӥåȥޥåפ */
    mgid->bmp.bounds.c.right = width;
    mgid->bmp.bounds.c.bottom = height;

    err = bmalloc(&(mgid->bmp));
    if (err < 0) {
        goto err_ret0;
    }

    /* Ķ */
    err = gopn_mem(NULL, &(mgid->bmp), (B*)&(mgid->cspec));
    if (err < 0) {
        goto err_ret1;
    }
    mgid->gid = err;

    return ER_OK;

 err_ret1:
    bfree(&(mgid->bmp));
 err_ret0:
    return err;
}


W clearMemGid(MemGid* mgid)
{
    PAT pat;

    if (mgid == NULL || mgid->gid < 0) {
        return ER_PAR;
    }

    /* ѥ */
    pat.spat.kind = 0;
    pat.spat.hsize = 16;
    pat.spat.vsize = 16;
    pat.spat.fgcol = mgid->bgcol;
    pat.spat.bgcol = mgid->bgcol;
    pat.spat.mask = FILL100;

    /* ɤĤ֤ */
    return gfil_rec(mgid->gid, mgid->bmp.bounds, &pat, 0, G_STORE);
}


W copyMemGid(W gid, int x, int y, MemGid* mgid)
{
    RECT r;

    if (gid < 0 || mgid == NULL) {
        return ER_PAR;
    }

    r.c.left = x;
    r.c.top = y;
    r.c.right = x + (mgid->bmp.bounds.c.right - mgid->bmp.bounds.c.left);
    r.c.bottom = y + (mgid->bmp.bounds.c.bottom - mgid->bmp.bounds.c.top);

    return grst_bmp(gid, &r, &(mgid->bmp), &(mgid->bmp.bounds), 
                    NULL, G_STORE);
}
