/*
 * SF-Reader: screen.C
 *
 *   ꡼
 *
 * (C)Copyright 2009, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdio.h>
#include <tcode.h>
#include <errcode.h>
#include <tstring.h>
#include <btron/message.h>
#include <btron/libapp.h>
#include "sfread.h"
#include "db.h"

#define FTC_GOTHIC 0x000000c0


W sfread_clear_screen()
{
    RECT r;
    PAT pat;
    PNT p1, p2;
    W mgid;
    int i;

    if (info.wgid < 0 || info.mgid == NULL) {
        return ER_PAR;
    }
    mgid = getMemGid(info.mgid);

    /* ӥåȥޥåΤΥꥢ */
    clearMemGid(info.mgid);

    /* Ĺɽꥢ(ɤĤ֤) */
    pat.spat.kind = 0;
    pat.spat.hsize = 16;
    pat.spat.vsize = 16;
    pat.spat.fgcol = SFREAD_SUM_COLOR;
    pat.spat.bgcol = SFREAD_SUM_COLOR;
    pat.spat.mask = FILL100;

    r.c.left = 12*1;
    r.c.top = 12*1;
    r.c.right = r.c.left + 12*20;
    r.c.bottom = r.c.top + 12*5;

    gfil_rec(mgid, r, &pat, 0, G_STORE);

    /* Ĺɽꥢ() */
    pat.spat.fgcol = SFREAD_SUM_COLOR_DARKER;

    p1.x = r.c.left;
    p1.y = r.c.top;
    p2.x = r.c.left;
    p2.y = r.c.bottom;
    gdra_lin(mgid, p1, p2, (LN_SOLID<<8 | 1), &pat, G_STORE);
    p2.x = r.c.right;
    p2.y = r.c.top;
    gdra_lin(mgid, p1, p2, (LN_SOLID<<8 | 1), &pat, G_STORE);

    pat.spat.fgcol = SFREAD_SUM_COLOR_BRIGHTER;

    p1.x = r.c.right;
    p1.y = r.c.bottom;
    p2.x = r.c.left;
    p2.y = r.c.bottom;
    gdra_lin(mgid, p1, p2, (LN_SOLID<<8 | 1), &pat, G_STORE);
    p2.x = r.c.right;
    p2.y = r.c.top;
    gdra_lin(mgid, p1, p2, (LN_SOLID<<8 | 1), &pat, G_STORE);

    /* ɽꥢ(ɤĤ֤) */
    r.c.left = 12*1;
    r.c.top = 12*7;
    r.c.right = r.c.left + 8*SFREAD_COLUMNS;
    r.c.bottom = r.c.top + 20 + 18*22;

    for (i = 0; i < 22; i++) {
        pat.spat.fgcol = ((i % 2) == 0) ? 
            SFREAD_STRIPE_COLOR1 : SFREAD_STRIPE_COLOR2;
        r.c.top = 12*7 + 20 + 18*i;
        r.c.bottom = r.c.top + 18;
        gfil_rec(mgid, r, &pat, 0, G_STORE);
    }

    /* ɽꥢ() */
    pat.spat.fgcol = SFREAD_BGCOLOR_DARKER;

    r.c.top = 12*7;
    r.c.bottom = r.c.top + 20 + 18*22;

    p1.x = r.c.left;
    p1.y = r.c.top;
    p2.x = r.c.left;
    p2.y = r.c.bottom;
    gdra_lin(mgid, p1, p2, (LN_SOLID<<8 | 1), &pat, G_STORE);
    p2.x = r.c.right;
    p2.y = r.c.top;
    gdra_lin(mgid, p1, p2, (LN_SOLID<<8 | 1), &pat, G_STORE);

    pat.spat.fgcol = SFREAD_BGCOLOR_BRIGHTER;

    p1.x = r.c.right;
    p1.y = r.c.bottom;
    p2.x = r.c.left;
    p2.y = r.c.bottom;
    gdra_lin(mgid, p1, p2, (LN_SOLID<<8 | 1), &pat, G_STORE);
    p2.x = r.c.right;
    p2.y = r.c.top;
    gdra_lin(mgid, p1, p2, (LN_SOLID<<8 | 1), &pat, G_STORE);    

    return 0;
}


#define SFREAD_HEADER_COLOR 0x1000458a
#define SFREAD_SUMSTR_COLOR 0x10004d00


W sfread_doc_render(GID gid, SFReadDoc* doc)
{
    FSSPEC font;
    W err;
    int i, j, len;
    UW fattr_hist = FT_REGULAR|FT_MIDI|FT_RIGHT|FT_SOLID|FT_GRAYSCALE;
    int x, y;
    int tab;
    TC str_yen[] = {L""};
    char str_sum[32];
    TC tstr_sum[16];
    int sum_width;
    TC ch;

    /* Ĺɽꥢ */
    tc_strcpy(font.name, (TC[]){L"ӣӣԣ"});
    font.fclass = FTC_MINCHO;
    font.attr = FT_REGULAR|FT_BOLD|FT_RIGHT|FT_SOLID|FT_GRAYSCALE|FT_PROP;
    font.size.h = 20;
    font.size.v = 28;

    gset_fon(gid, &font);
    gset_chc(gid, SFREAD_SUMSTR_COLOR, SFREAD_SUM_COLOR);

    gdra_stp(gid, 12*1 + 12, 12*1 + 12*5 - 8, 
             str_yen, sizeof(str_yen)/sizeof(TC), G_STORE);

    font.size.h = 48;
    font.size.v = 48;
    gset_fon(gid, &font);

    if (doc->sum >= 1000) {
        sprintf(str_sum, "%d,%03d", doc->sum / 1000, doc->sum % 1000);
    }
    else {
        sprintf(str_sum, "%d", doc->sum);
    }
    eucstotcs(tstr_sum, str_sum);

    err = gget_stw(gid, tstr_sum, sizeof(tstr_sum)/sizeof(TC), NULL, NULL);
    sum_width = (err >= 0) ? err : (font.size.h * tc_strlen(tstr_sum));

    gdra_stp(gid, 12*1 + 12*20 - 12 - sum_width, 12*1 + 12*5 - 8,
             tstr_sum, sizeof(tstr_sum)/sizeof(TC), G_STORE);

    /* ɽꥢ(إå) */
    tc_strcpy(font.name, (TC[]){L"å"});
    font.fclass = FTC_GOTHIC;
    font.attr = fattr_hist;
    font.size.h = 16;
    font.size.v = 16;

    gset_fon(gid, &font);
    gset_chc(gid, SFREAD_HEADER_COLOR, SFREAD_BGCOLOR);

    y = 12*7 + 18;
    x = 12*1 + 4;
    if (doc->attr[0] & SFREAD_COLUMN_ATTR_RIGHT) {
        for (len = 0; 
             doc->data[i][len] != '\0' && doc->data[i][len] != '\t'; 
             len++) {
            ;
        }
        gset_chp(gid, x + 8*(doc->width[0] - len) - 4 - 8, 
                 y, 1);
    }
    else {
        gset_chp(gid, x, y, 1);
    }

    for (tab = 0, j = 0; 
         doc->header[j] != '\0' && tab < doc->ncolumns; ) {
        if (doc->header[j] == '\t') {
            /* ֤褿ΤǼηذư */
            x += 8 * doc->width[tab];
            tab++;
            j++;
            if (doc->attr[tab] & SFREAD_COLUMN_ATTR_RIGHT) {
                for (len = 0; 
                     doc->header[len+j] != '\0' 
                         && doc->header[len+j] != '\t'; 
                     len++) {
                    ;
                }
                gset_chp(gid, x + 8*(doc->width[tab] - len) - 4 - 8, 
                         y, 1);
            }
            else {
                gset_chp(gid, x, y, 1);
            }
        }
        else {
            /* TRONʸѴ */
            err = euctotc(&ch, &(doc->header[j]));
            if (err <= 0) {
                printf("SF-Reader: bad character %02x",
                       doc->header[j] & 0xff);
                j++;
                continue;
            }

            /* եȤȾѡѤڤؤ */
            if (err == 1 && font.size.h >= font.size.v) {
                font.size.h = font.size.v / 2;
                gset_fon(gid, &font);
            }
            else if (err == 2 && font.size.h < font.size.v) {
                font.size.h = font.size.v;
                gset_fon(gid, &font);
            }

            /* ʸ */
            gdra_chr(gid, ch, G_STORE);
            j += err;
        }
    }

    /* ɽꥢ() */
    tc_strcpy(font.name, (TC[]){L"ī"});
    font.fclass = FTC_MINCHO;

    for (i = 0; i < doc->nrows; i++) {
        if (doc->data[i] == NULL) {
            continue;
        }
        //printf("row[%02d]: %s\n", i, doc->data[i]);

        /* եȡʸ */
        font.attr = fattr_hist |
            ((doc->attr[0] & SFREAD_COLUMN_ATTR_PROP) ?
             FT_PROP : FT_FIXED);
        gset_fon(gid, &font);
        gset_chc(gid, 0x10000000, 
                 ((i % 2) == 0) ? 
                 SFREAD_STRIPE_COLOR1 : SFREAD_STRIPE_COLOR2);

        y = 12*7 + 20 + i * 18 + 17;
        x = 12*1 + 4;
        if (doc->attr[0] & SFREAD_COLUMN_ATTR_RIGHT) {
            for (len = 0; 
                 doc->data[i][len] != '\0' && doc->data[i][len] != '\t'; 
                 len++) {
                ;
            }
            gset_chp(gid, x + 8*(doc->width[0] - len) - 4 - 8, 
                     y, 1);
        }
        else {
            gset_chp(gid, x, y, 1);
        }

        /*  */
        for (tab = 0, j = 0; 
             doc->data[i][j] != '\0' && tab < doc->ncolumns; ) {
            if (doc->data[i][j] == '\t') {
                /* ֤褿ΤǼηذư */
                x += 8 * doc->width[tab];
                tab++;
                font.attr = fattr_hist |
                    ((doc->attr[tab] & SFREAD_COLUMN_ATTR_PROP) ?
                     FT_PROP : FT_FIXED);
                gset_fon(gid, &font);
                j++;
                if (doc->attr[tab] & SFREAD_COLUMN_ATTR_RIGHT) {
                    for (len = 0; 
                         doc->data[i][len+j] != '\0' 
                             && doc->data[i][len+j] != '\t'; 
                         len++) {
                        ;
                    }
                    gset_chp(gid, x + 8*(doc->width[tab] - len) - 4 - 8, 
                             y, 1);
                }
                else {
                    gset_chp(gid, x, y, 1);
                }
            }
            else {
                /* TRONʸѴ */
                err = euctotc(&ch, &(doc->data[i][j]));
                if (err <= 0) {
                    printf("SF-Reader: bad character %02x",
                           doc->data[i][j] & 0xff);
                    j++;
                    continue;
                }

                /* եȤȾѡѤڤؤ */
                if (err == 1 && font.size.h >= font.size.v) {
                    font.size.h = font.size.v / 2;
                    gset_fon(gid, &font);
                }
                else if (err == 2 && font.size.h < font.size.v) {
                    font.size.h = font.size.v;
                    gset_fon(gid, &font);
                }

                /* ʸ */
                gdra_chr(gid, ch, G_STORE);
                j += err;
            }
        }
    }

    return 0;
}


