/*
 * SF-Reader: sfdoc.c
 *
 *   ɤ߹ߥǡ
 *
 * (C)Copyright 2009, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdlib.h>
#include <bassert.h>
#include "sfdoc.h"


SFReadDoc* sfread_doc_init(const char* header, const int* width, 
                           const int* attr, int ncolumns)
{
    SFReadDoc* doc;

    doc = (SFReadDoc*)malloc(sizeof(SFReadDoc));
    if (doc == NULL) {
        return NULL;
    }

    memset(doc, 0, sizeof(SFReadDoc));

    doc->ncolumns = ncolumns;
    doc->nrows = 0;
    doc->width = width;
    doc->attr = attr;
    doc->header = header;
    doc->sum = 0;

    return doc;
}


void sfread_doc_cleanup(SFReadDoc* doc)
{
    int i;

    if (doc == NULL) {
        return;
    }

    for (i = 0; i < doc->nrows; i++) {
        free(doc->data[i]);
    }
    free(doc);
}


void sfread_doc_appendRow(SFReadDoc* doc, char* row)
{
    assert(doc != NULL);

    doc->data[doc->nrows] = row;
    doc->nrows++;
}


int sfread_tsv_getnth(char* target, char* src, int slen, int nth)
{
    int i;
    int len = 0;
    int ntabs = 0;

    for (i = 0; 
         ntabs <= nth && i < slen && src[i] != '\0';
         i++) {
        if (src[i] == '\t') {
            ntabs++;
        }
        else if (ntabs == nth) {
            target[len] = src[i];
            len++;
        }
    }

    target[len] = '\0';
    return len;
}


