/*
 * SF-Reader: sfdoc.h
 *
 *   ɤ߹ߥǡ
 *
 * (C)Copyright 2009, Yashiro Takeshi
 */

#ifndef _DEFINE_H_SFREAD_SFDOC_
#define _DEFINE_H_SFREAD_SFDOC_

#include <basic.h>

#define PASORI_MAX_RECORDS 32
#define PASORI_MAX_COLUMNS 10
#define PASORI_MAX_DATASTR 24

#define SFREAD_COLUMN_ATTR_RIGHT     0x01
#define SFREAD_COLUMN_ATTR_PROP      0x02

/*
 * ɾ
 */
typedef struct SFReadDoc_ {
    int ncolumns;
    int nrows;
    const int* width;
    const int* attr;
    const char* header; /* ƹܤϥֶڤ */
    char* data[PASORI_MAX_RECORDS]; /* ƹܤϥֶڤ */
    int sum; /* ǽŪʻĹ */
} SFReadDoc;


extern SFReadDoc* sfread_doc_init(const char* header, const int* width, 
                                  const int* attr, int ncolumns);
extern void sfread_doc_cleanup(SFReadDoc* doc);

extern void sfread_doc_appendRow(SFReadDoc* doc, char* row);

static inline char* sfread_doc_getRow(SFReadDoc* doc, int row)
{
    if (doc == NULL || row < 0 || row >= doc->nrows) {
        return NULL;
    }
    return doc->data[row];
}

static inline const char* sfread_doc_getHeader(SFReadDoc* doc)
{
    if (doc == NULL) {
        return NULL;
    }
    return doc->header;
}

/*
 * 桼ƥƥؿ
 */
extern int sfread_tsv_getnth(char* target, char* src, int slen, int nth);


#endif /* _DEFINE_H_SFREAD_SFDOC_ */
