/*
 * SF-Reader: tray.c
 *
 *   ȥ졼ؤνϽ
 *
 * (C)Copyright 2009, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdio.h>
#include <bstdlib.h>
#include <tcode.h>
#include <tlang.h>
#include <tstring.h>
#include <btron/dp.h>
#include <tad.h>
#include <btron/taddata.h>
#include <errcode.h>
#include "sfread.h"
#include "sfdoc.h"


W sfread_put_tray(SFReadDoc* doc, Bool tmp)
{
    TRAYREC data[2];
    TEXTSEG tseg;
    TC* str = NULL;
    W err = 0;
    int i, len;

    if (doc == NULL) {
        return ER_PAR;
    }

    /* EUCʸĹ׻ */
    len = 0;
    for (i = 0; i < doc->nrows; i++) {
        if (doc->data[i] == NULL) {
            continue;
        }
        len += strlen(doc->data[i]);
        len++; /* ʸʬ */
    }

    /* TCʸǼΤɬפʥmalloc */
    str = (TC*)malloc((len+1) * sizeof(TC));
    if (str == NULL) {
        return ER_NOMEM;
    }

    /* ʸϳϥ */
    memset(&tseg, 0, sizeof(tseg));
    tseg.h_unit = -120;
    tseg.v_unit = -120;
    tseg.lang = TSC_SYS;
    tseg.bgpat = 0;

    data[0].id  = TS_TEXT;
    data[0].len = sizeof(tseg);
    data[0].dt  = (B*)&tseg;

    /* ʸǡ */
    len = 0;
    for (i = 0; i < doc->nrows; i++) {
        if (doc->data[i] == NULL) {
            continue;
        }
        err = eucstotcs(&(str[len]), doc->data[i]);
        if (err > 0) {
            len += err;
            str[len] = TK_NL;
            len++;
        }
    }
    str[len] = TNULL;

    data[1].id  = TR_TEXT;
    data[1].len = len * sizeof(TC);
    data[1].dt  = (B*)str;

    if (tmp) {
        /* ȥ졼˳Ǽ */
        err = tset_dat(data, sizeof(data)/sizeof(data[0]));
    }
    else {
        /* ̾ȥ졼˳Ǽ */
        err = tpsh_dat(data, sizeof(data)/sizeof(data[0]), NULL);
    }

    free(str);
    return err;
}

